<script setup lang="ts">
import _ from 'lodash'
import type { QAType } from '~/store/qa'
import { useQAStore } from '~/store/qa'

interface QuestionDetailProps {
  data: QAType
  id: string
  full: boolean
}

const {
  data,
  id,
  full,
} = defineProps<QuestionDetailProps>()
const answer = ref('')
const Qa = useQAStore()

// answering
const answering = ref(!data.answerer)
const submit = () => {
  Qa.answerQuestion(answer.value, data.id)
  answering.value = false
}
const tick = () => {
  Qa.tickQuestion(id)
  answering.value = false
}
const s = new Date(data.timeStamp).toLocaleTimeString('it-IT')
const status = computed(() => (data.answerer ? (data.answer ? 2 : 1) : 0))
</script>

<template>
  <div class="flex flex-col items-stretch mt-2 mb-5">
    <div class="flex flex-row">
      <div class="w-16 flex justify-center items-center">
        <AAvatar :name="data.user.name" />
      </div>
      <div>
        <p class="text-sm">
          {{ data.user.name }} {{ s }}
        </p>
        <p class="text-lg" />
        <p class="text-lg pr-2 break-all text-left">
          {{ data.question }}
        </p>
      </div>
    </div>
    <div class="flex flex-col gap-1 text-lg flex-1 pl-5 pt-2">
      <div v-show="full && answering" class="flex flex-wrap w-full gap-2">
        <p class="w-full text-smshop">
          返信
        </p>
        <input
          v-model="answer" type="text"
          class="flex-1 text-lg border border-black outline-0 p-2 dark:bg-neutral-700"
        >
        <div>
          <button :disabled="answer === ''" class="bg-blue-500 px-4 py-1 rounded text-white" @click="submit">
            送信
          </button>
        </div>
        <div v-if="!data.answerer" class="w-full flex">
          <button class="bg-blue-500 px-4 py-1 rounded text-white ml-auto" @click="tick">
            口頭で回答する
          </button>
        </div>
      </div>
      <div class="w-full text-sm">
        <div class="flex">
          <ALabel :code="status" />
          <button
            v-if="full && data.answerer"
            class="bg-gray-300 px-2 py-1 rounded dark:bg-neutral-900 dark:border dark:border-blue-300"
            @click="answering = !answering"
          >
            {{ answering ? "編集終了" : "編集する" }}
          </button>
        </div>
        <p v-if="data.answer" class="text-lg break-all">
          {{ data.answer }}
        </p>
      </div>
    </div>
  </div>
</template>

<style scoped></style>
